diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lr-wpan/model/lr-wpan-mac.cc ns-3.40/src/lr-wpan/model/lr-wpan-mac.cc
--- ns-3.39/src/lr-wpan/model/lr-wpan-mac.cc	2023-07-05 14:23:47.869427400 -0700
+++ ns-3.40/src/lr-wpan/model/lr-wpan-mac.cc	2023-09-27 13:30:37.674839300 -0700
@@ -183,6 +183,7 @@
     m_numCsmacaRetry = 0;
     m_txPkt = nullptr;
     m_rxPkt = nullptr;
+    m_lastRxFrameLqi = 0;
     m_ifs = 0;
 
     m_macLIFSPeriod = 40;
@@ -847,7 +848,7 @@
     NS_LOG_FUNCTION(this);
     NS_ASSERT(params.m_logCh <= 26 && m_macPanId != 0xffff);
 
-    uint64_t symbolRate = (uint64_t)m_phy->GetDataOrSymbolRate(false); // symbols per second
+    auto symbolRate = (uint64_t)m_phy->GetDataOrSymbolRate(false); // symbols per second
     // change phy current logical channel
     Ptr<LrWpanPhyPibAttributes> pibAttr = Create<LrWpanPhyPibAttributes>();
     pibAttr->phyCurrentChannel = params.m_logCh;
@@ -1659,7 +1660,7 @@
 void
 LrWpanMac::BeaconSearchTimeout()
 {
-    uint64_t symbolRate = (uint64_t)m_phy->GetDataOrSymbolRate(false); // symbols per second
+    auto symbolRate = (uint64_t)m_phy->GetDataOrSymbolRate(false); // symbols per second
 
     if (m_numLostBeacons > lrwpan::aMaxLostBeacons)
     {
@@ -1871,8 +1872,8 @@
     // srcPanId = m_macPanId if only srcAddr field in Data or Command frame,accept frame if
     // srcPanId=m_macPanId
 
-    Ptr<Packet> originalPkt = p->Copy(); // because we will strip headers
-    uint64_t symbolRate = (uint64_t)m_phy->GetDataOrSymbolRate(false); // symbols per second
+    Ptr<Packet> originalPkt = p->Copy();                           // because we will strip headers
+    auto symbolRate = (uint64_t)m_phy->GetDataOrSymbolRate(false); // symbols per second
     m_promiscSnifferTrace(originalPkt);
 
     m_macPromiscRxTrace(originalPkt);
@@ -1974,21 +1975,6 @@
                               (m_macPanId == 0xffff && receivedMacHdr.IsCommand());
             }
 
-            if (acceptFrame && (receivedMacHdr.GetShortDstAddr() == Mac16Address("FF:FF")))
-            {
-                // TODO: shouldn't this be filtered by the PHY?
-                // A broadcast message (e.g. beacons, orphan notifications) should not be received
-                // by the device who issues it.
-                if (receivedMacHdr.GetSrcAddrMode() == EXT_ADDR)
-                {
-                    acceptFrame = (receivedMacHdr.GetExtSrcAddr() != GetExtendedAddress());
-                }
-                else
-                {
-                    acceptFrame = (receivedMacHdr.GetShortSrcAddr() != GetShortAddress());
-                }
-            }
-
             if (acceptFrame && (receivedMacHdr.GetDstAddrMode() == SHORT_ADDR))
             {
                 if (receivedMacHdr.GetShortDstAddr() == m_shortAddress)
@@ -2108,9 +2094,10 @@
                     m_setMacState.Cancel();
                     ChangeMacState(MAC_IDLE);
 
-                    // save received packet to process the appropriate indication/response after
-                    // sending ACK (PD-DATA.confirm)
+                    // save received packet and LQI to process the appropriate indication/response
+                    // after sending ACK (PD-DATA.confirm)
                     m_rxPkt = originalPkt->Copy();
+                    m_lastRxFrameLqi = lqi;
 
                     // LOG Commands with ACK required.
                     CommandPayloadHeader receivedMacPayload;
@@ -2680,7 +2667,7 @@
 void
 LrWpanMac::IfsWaitTimeout(Time ifsTime)
 {
-    uint64_t symbolRate = (uint64_t)m_phy->GetDataOrSymbolRate(false);
+    auto symbolRate = (uint64_t)m_phy->GetDataOrSymbolRate(false);
     Time lifsTime = Seconds((double)m_macLIFSPeriod / symbolRate);
     Time sifsTime = Seconds((double)m_macSIFSPeriod / symbolRate);
 
@@ -2947,34 +2934,37 @@
 }
 
 void
-LrWpanMac::PrintPendTxQ(std::ostream& os) const
+LrWpanMac::PrintPendingTxQueue(std::ostream& os) const
 {
     LrWpanMacHeader peekedMacHdr;
 
     os << "Pending Transaction List [" << GetShortAddress() << " | " << GetExtendedAddress()
        << "] | CurrentTime: " << Simulator::Now().As(Time::S) << "\n"
-       << "       Destination        | Sequence Number |   Frame type    | Expire time\n";
-
-    for (uint32_t i = 0; i < m_indTxQueue.size(); i++)
-    {
-        m_indTxQueue[i]->txQPkt->PeekHeader(peekedMacHdr);
-        os << m_indTxQueue[i]->dstExtAddress << "           "
-           << static_cast<uint32_t>(m_indTxQueue[i]->seqNum) << "          ";
+       << "    Destination    |"
+       << "    Sequence Number |"
+       << "    Frame type    |"
+       << "    Expire time\n";
+
+    for (auto transaction : m_indTxQueue)
+    {
+        transaction->txQPkt->PeekHeader(peekedMacHdr);
+        os << transaction->dstExtAddress << "           "
+           << static_cast<uint32_t>(transaction->seqNum) << "          ";
 
         if (peekedMacHdr.IsCommand())
         {
-            os << "Cmd Frame    ";
+            os << " Command Frame   ";
         }
         else if (peekedMacHdr.IsData())
         {
-            os << "Data Frame   ";
+            os << " Data Frame      ";
         }
         else
         {
-            os << "Unk Frame    ";
+            os << " Unknown Frame   ";
         }
 
-        os << m_indTxQueue[i]->expireTime.As(Time::S) << "\n";
+        os << transaction->expireTime.As(Time::S) << "\n";
     }
 }
 
@@ -2985,11 +2975,14 @@
 
     os << "\nTx Queue [" << GetShortAddress() << " | " << GetExtendedAddress()
        << "] | CurrentTime: " << Simulator::Now().As(Time::S) << "\n"
-       << "       Destination                 | Sequence Number |  Dst PAN id | Frame type    |\n";
+       << "    Destination    |"
+       << "    Sequence Number    |"
+       << "    Dst PAN id    |"
+       << "    Frame type    |\n";
 
-    for (uint32_t i = 0; i < m_indTxQueue.size(); i++)
+    for (auto transaction : m_txQueue)
     {
-        m_txQueue[i]->txQPkt->PeekHeader(peekedMacHdr);
+        transaction->txQPkt->PeekHeader(peekedMacHdr);
 
         os << "[" << peekedMacHdr.GetShortDstAddr() << "]"
            << ", [" << peekedMacHdr.GetExtDstAddr() << "]        "
@@ -2998,15 +2991,15 @@
 
         if (peekedMacHdr.IsCommand())
         {
-            os << "Cmd Frame    ";
+            os << " Command Frame   ";
         }
         else if (peekedMacHdr.IsData())
         {
-            os << "Data Frame   ";
+            os << " Data Frame      ";
         }
         else
         {
-            os << "Unk Frame    ";
+            os << " Unknown Frame   ";
         }
 
         os << "\n";
@@ -3185,9 +3178,13 @@
                 {
                     if (!m_mlmeAssociateIndicationCallback.IsNull())
                     {
+                        // NOTE: The LQI parameter is not part of the standard but found
+                        // in some implementations as is required for higher layers (See Zboss
+                        // implementation).
                         MlmeAssociateIndicationParams associateParams;
                         associateParams.capabilityInfo = receivedMacPayload.GetCapabilityField();
                         associateParams.m_extDevAddr = receivedMacHdr.GetExtSrcAddr();
+                        associateParams.lqi = m_lastRxFrameLqi;
                         m_mlmeAssociateIndicationCallback(associateParams);
                     }
 
@@ -3202,15 +3199,13 @@
                     switch (receivedMacPayload.GetAssociationStatus())
                     {
                     case CommandPayloadHeader::SUCCESSFUL:
-                        confirmParams.m_status =
-                            LrWpanMlmeAssociateConfirmStatus::MLMEASSOC_SUCCESS;
-                        // The original short address used in the association
-                        // used in the association request
-                        confirmParams.m_assocShortAddr = GetShortAddress();
-
                         // The assigned short address by the coordinator
                         SetShortAddress(receivedMacPayload.GetShortAddr());
                         m_macPanId = receivedMacHdr.GetSrcPanId();
+
+                        confirmParams.m_status =
+                            LrWpanMlmeAssociateConfirmStatus::MLMEASSOC_SUCCESS;
+                        confirmParams.m_assocShortAddr = GetShortAddress();
                         break;
                     case CommandPayloadHeader::FULL_CAPACITY:
                         confirmParams.m_status =
@@ -3424,7 +3419,7 @@
     {
         if (status == LrWpanPhyEnumeration::IEEE_802_15_4_PHY_SUCCESS)
         {
-            uint64_t symbolRate = static_cast<uint64_t>(m_phy->GetDataOrSymbolRate(false));
+            auto symbolRate = static_cast<uint64_t>(m_phy->GetDataOrSymbolRate(false));
             Time nextScanTime;
 
             if (m_scanParams.m_scanType == MLMESCAN_ORPHAN)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lr-wpan/model/lr-wpan-mac.h ns-3.40/src/lr-wpan/model/lr-wpan-mac.h
--- ns-3.39/src/lr-wpan/model/lr-wpan-mac.h	2023-07-05 14:23:47.869427400 -0700
+++ ns-3.40/src/lr-wpan/model/lr-wpan-mac.h	2023-09-27 13:30:37.674839300 -0700
@@ -25,9 +25,10 @@
 #ifndef LR_WPAN_MAC_H
 #define LR_WPAN_MAC_H
 
+#include "lr-wpan-fields.h"
+#include "lr-wpan-phy.h"
+
 #include <ns3/event-id.h>
-#include <ns3/lr-wpan-fields.h>
-#include <ns3/lr-wpan-phy.h>
 #include <ns3/mac16-address.h>
 #include <ns3/mac64-address.h>
 #include <ns3/object.h>
@@ -447,9 +448,11 @@
  */
 struct MlmeAssociateIndicationParams
 {
-    Mac64Address m_extDevAddr; //!< The extended address of the device requesting association
-    CapabilityField
-        capabilityInfo; //!< The operational capabilities of the device requesting association.
+    Mac64Address m_extDevAddr;      //!< The extended address of the device requesting association
+    CapabilityField capabilityInfo; //!< The operational capabilities of
+                                    //!< the device requesting association.
+    uint8_t lqi{0}; //!< The link quality indicator of the received associate request command
+                    //!< (Not officially supported in the standard but found in implementations)
 };
 
 /**
@@ -1584,7 +1587,7 @@
      * Print the Pending transaction list.
      * \param os The reference to the output stream used by this print function.
      */
-    void PrintPendTxQ(std::ostream& os) const;
+    void PrintPendingTxQueue(std::ostream& os) const;
 
     /**
      * Print the Transmit Queue.
@@ -2219,6 +2222,11 @@
     uint8_t m_numCsmacaRetry;
 
     /**
+     * Keep track of the last received frame Link Quality Indicator
+     */
+    uint8_t m_lastRxFrameLqi;
+
+    /**
      * Scheduler event for the ACK timeout of the currently transmitted data
      * packet.
      */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lr-wpan/model/lr-wpan-mac-trailer.cc ns-3.40/src/lr-wpan/model/lr-wpan-mac-trailer.cc
--- ns-3.39/src/lr-wpan/model/lr-wpan-mac-trailer.cc	2023-07-05 14:23:47.869427400 -0700
+++ ns-3.40/src/lr-wpan/model/lr-wpan-mac-trailer.cc	2023-09-27 13:30:37.670839000 -0700
@@ -93,7 +93,7 @@
     if (m_calcFcs)
     {
         uint16_t size = p->GetSize();
-        uint8_t* serial_packet = new uint8_t[size];
+        auto serial_packet = new uint8_t[size];
 
         p->CopyData(serial_packet, size);
 
@@ -115,7 +115,7 @@
     {
         uint16_t checkFcs;
         uint16_t size = p->GetSize();
-        uint8_t* serial_packet = new uint8_t[size];
+        auto serial_packet = new uint8_t[size];
 
         p->CopyData(serial_packet, size);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lr-wpan/model/lr-wpan-net-device.h ns-3.40/src/lr-wpan/model/lr-wpan-net-device.h
--- ns-3.39/src/lr-wpan/model/lr-wpan-net-device.h	2023-07-05 14:23:47.869427400 -0700
+++ ns-3.40/src/lr-wpan/model/lr-wpan-net-device.h	2023-09-27 13:30:37.674839300 -0700
@@ -22,7 +22,8 @@
 #ifndef LR_WPAN_NET_DEVICE_H
 #define LR_WPAN_NET_DEVICE_H
 
-#include <ns3/lr-wpan-mac.h>
+#include "lr-wpan-mac.h"
+
 #include <ns3/net-device.h>
 #include <ns3/traced-callback.h>
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lr-wpan/test/lr-wpan-mac-test.cc ns-3.40/src/lr-wpan/test/lr-wpan-mac-test.cc
--- ns-3.39/src/lr-wpan/test/lr-wpan-mac-test.cc	2023-07-05 14:23:47.869427400 -0700
+++ ns-3.40/src/lr-wpan/test/lr-wpan-mac-test.cc	2023-09-27 13:30:37.674839300 -0700
@@ -308,6 +308,7 @@
      * \param params MLME scan confirm parameters
      */
     void ScanConfirm(MlmeScanConfirmParams params);
+
     /**
      * Function used to notify the reception of a beacon with payload.
      *
@@ -380,9 +381,16 @@
     Ptr<LrWpanNetDevice> endNodeNetDevice = CreateObject<LrWpanNetDevice>();
     Ptr<LrWpanNetDevice> coord2NetDevice = CreateObject<LrWpanNetDevice>();
 
-    coord1NetDevice->SetAddress(Mac16Address("00:01"));
-    endNodeNetDevice->SetAddress(Mac16Address("00:02"));
-    coord2NetDevice->SetAddress(Mac16Address("00:03"));
+    // PAN coordinators typically have a short address = 00:00 (e.g. Zigbee networks)
+    coord1NetDevice->GetMac()->SetExtendedAddress("00:00:00:00:00:00:CA:FE");
+    coord1NetDevice->GetMac()->SetShortAddress(Mac16Address("00:00"));
+
+    coord2NetDevice->GetMac()->SetExtendedAddress("00:00:00:00:00:00:BE:BE");
+    coord2NetDevice->GetMac()->SetShortAddress(Mac16Address("00:00"));
+
+    // An end device currently not associated (short address = ff:ff)
+    endNodeNetDevice->GetMac()->SetExtendedAddress("00:00:00:00:00:00:00:03");
+    endNodeNetDevice->GetMac()->SetShortAddress(Mac16Address("ff:ff"));
 
     // Configure Spectrum channel
     Ptr<SingleModelSpectrumChannel> channel = CreateObject<SingleModelSpectrumChannel>();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/examples/lena-cc-helper.cc ns-3.40/src/lte/examples/lena-cc-helper.cc
--- ns-3.39/src/lte/examples/lena-cc-helper.cc	2023-07-05 14:23:47.897427600 -0700
+++ ns-3.40/src/lte/examples/lena-cc-helper.cc	2023-09-27 13:30:37.702839100 -0700
@@ -44,10 +44,8 @@
 
     std::map<uint8_t, ComponentCarrier> ccm = cch->EquallySpacedCcs();
 
-    std::map<uint8_t, ComponentCarrier>::iterator it;
-
     std::cout << " CcMap size " << ccm.size() << std::endl;
-    for (it = ccm.begin(); it != ccm.end(); it++)
+    for (auto it = ccm.begin(); it != ccm.end(); it++)
     {
         Print(it->second);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/examples/lena-deactivate-bearer.cc ns-3.40/src/lte/examples/lena-deactivate-bearer.cc
--- ns-3.39/src/lte/examples/lena-deactivate-bearer.cc	2023-07-05 14:23:47.897427600 -0700
+++ ns-3.40/src/lte/examples/lena-deactivate-bearer.cc	2023-09-27 13:30:37.702839100 -0700
@@ -69,7 +69,7 @@
     Ptr<Node> pgw = epcHelper->GetPgwNode();
 
     // Enable Logging
-    LogLevel logLevel = (LogLevel)(LOG_PREFIX_FUNC | LOG_PREFIX_TIME | LOG_LEVEL_ALL);
+    auto logLevel = (LogLevel)(LOG_PREFIX_FUNC | LOG_PREFIX_TIME | LOG_LEVEL_ALL);
 
     LogComponentEnable("BearerDeactivateExample", LOG_LEVEL_ALL);
     LogComponentEnable("LteHelper", logLevel);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/examples/lena-distributed-ffr.cc ns-3.40/src/lte/examples/lena-distributed-ffr.cc
--- ns-3.39/src/lte/examples/lena-distributed-ffr.cc	2023-07-05 14:23:47.897427600 -0700
+++ ns-3.40/src/lte/examples/lena-distributed-ffr.cc	2023-09-27 13:30:37.702839100 -0700
@@ -45,7 +45,7 @@
         NS_LOG_ERROR("Can't open file " << filename);
         return;
     }
-    for (NodeList::Iterator it = NodeList::Begin(); it != NodeList::End(); ++it)
+    for (auto it = NodeList::Begin(); it != NodeList::End(); ++it)
     {
         Ptr<Node> node = *it;
         int nDevs = node->GetNDevices();
@@ -74,7 +74,7 @@
         NS_LOG_ERROR("Can't open file " << filename);
         return;
     }
-    for (NodeList::Iterator it = NodeList::Begin(); it != NodeList::End(); ++it)
+    for (auto it = NodeList::Begin(); it != NodeList::End(); ++it)
     {
         Ptr<Node> node = *it;
         int nDevs = node->GetNDevices();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/examples/lena-dual-stripe.cc ns-3.40/src/lte/examples/lena-dual-stripe.cc
--- ns-3.39/src/lte/examples/lena-dual-stripe.cc	2023-07-05 14:23:47.897427600 -0700
+++ ns-3.40/src/lte/examples/lena-dual-stripe.cc	2023-09-27 13:30:37.702839100 -0700
@@ -158,7 +158,7 @@
 bool
 FemtocellBlockAllocator::OverlapsWithAnyPrevious(Box box)
 {
-    for (std::list<Box>::iterator it = m_previousBlocks.begin(); it != m_previousBlocks.end(); ++it)
+    for (auto it = m_previousBlocks.begin(); it != m_previousBlocks.end(); ++it)
     {
         if (AreOverlapping(*it, box))
         {
@@ -184,7 +184,7 @@
         return;
     }
     uint32_t index = 0;
-    for (BuildingList::Iterator it = BuildingList::Begin(); it != BuildingList::End(); ++it)
+    for (auto it = BuildingList::Begin(); it != BuildingList::End(); ++it)
     {
         ++index;
         Box box = (*it)->GetBoundaries();
@@ -208,7 +208,7 @@
         NS_LOG_ERROR("Can't open file " << filename);
         return;
     }
-    for (NodeList::Iterator it = NodeList::Begin(); it != NodeList::End(); ++it)
+    for (auto it = NodeList::Begin(); it != NodeList::End(); ++it)
     {
         Ptr<Node> node = *it;
         int nDevs = node->GetNDevices();
@@ -242,7 +242,7 @@
         NS_LOG_ERROR("Can't open file " << filename);
         return;
     }
-    for (NodeList::Iterator it = NodeList::Begin(); it != NodeList::End(); ++it)
+    for (auto it = NodeList::Begin(); it != NodeList::End(); ++it)
     {
         Ptr<Node> node = *it;
         int nDevs = node->GetNDevices();
@@ -714,7 +714,7 @@
         // forcing initialization so we don't have to wait for Nodes to
         // start before positions are assigned (which is needed to
         // output node positions to file and to make AttachToClosestEnb work)
-        for (NodeContainer::Iterator it = macroUes.Begin(); it != macroUes.End(); ++it)
+        for (auto it = macroUes.Begin(); it != macroUes.End(); ++it)
         {
             (*it)->Initialize();
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/examples/lena-frequency-reuse.cc ns-3.40/src/lte/examples/lena-frequency-reuse.cc
--- ns-3.39/src/lte/examples/lena-frequency-reuse.cc	2023-07-05 14:23:47.897427600 -0700
+++ ns-3.40/src/lte/examples/lena-frequency-reuse.cc	2023-09-27 13:30:37.702839100 -0700
@@ -41,7 +41,7 @@
         NS_LOG_ERROR("Can't open file " << filename);
         return;
     }
-    for (NodeList::Iterator it = NodeList::Begin(); it != NodeList::End(); ++it)
+    for (auto it = NodeList::Begin(); it != NodeList::End(); ++it)
     {
         Ptr<Node> node = *it;
         int nDevs = node->GetNDevices();
@@ -70,7 +70,7 @@
         NS_LOG_ERROR("Can't open file " << filename);
         return;
     }
-    for (NodeList::Iterator it = NodeList::Begin(); it != NodeList::End(); ++it)
+    for (auto it = NodeList::Begin(); it != NodeList::End(); ++it)
     {
         Ptr<Node> node = *it;
         int nDevs = node->GetNDevices();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/examples/lena-radio-link-failure.cc ns-3.40/src/lte/examples/lena-radio-link-failure.cc
--- ns-3.39/src/lte/examples/lena-radio-link-failure.cc	2023-07-05 14:23:47.901427700 -0700
+++ ns-3.40/src/lte/examples/lena-radio-link-failure.cc	2023-09-27 13:30:37.702839100 -0700
@@ -49,7 +49,7 @@
 void
 PrintUePosition(uint64_t imsi)
 {
-    for (NodeList::Iterator it = NodeList::Begin(); it != NodeList::End(); ++it)
+    for (auto it = NodeList::Begin(); it != NodeList::End(); ++it)
     {
         Ptr<Node> node = *it;
         int nDevs = node->GetNDevices();
@@ -381,7 +381,7 @@
 
     if (enableNsLogs)
     {
-        LogLevel logLevel =
+        auto logLevel =
             (LogLevel)(LOG_PREFIX_FUNC | LOG_PREFIX_NODE | LOG_PREFIX_TIME | LOG_LEVEL_ALL);
         LogComponentEnable("LteUeRrc", logLevel);
         LogComponentEnable("LteUeMac", logLevel);
@@ -632,7 +632,7 @@
     Config::ConnectWithoutContext(oss.str(), MakeCallback(&ReceivePacket));
 
     bool firstWrite = true;
-    std::string rrcType = useIdealRrc == 1 ? "ideal_rrc" : "real_rrc";
+    std::string rrcType = useIdealRrc ? "ideal_rrc" : "real_rrc";
     std::string fileName = "rlf_dl_thrput_" + std::to_string(enbNodes.GetN()) + "_eNB_" + rrcType;
     Time binSize = Seconds(0.2);
     Simulator::Schedule(Seconds(0.47), &Throughput, firstWrite, binSize, fileName);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/helper/lte-global-pathloss-database.cc ns-3.40/src/lte/helper/lte-global-pathloss-database.cc
--- ns-3.39/src/lte/helper/lte-global-pathloss-database.cc	2023-07-05 14:23:47.901427700 -0700
+++ ns-3.40/src/lte/helper/lte-global-pathloss-database.cc	2023-09-27 13:30:37.702839100 -0700
@@ -38,14 +38,9 @@
 LteGlobalPathlossDatabase::Print()
 {
     NS_LOG_FUNCTION(this);
-    for (std::map<uint16_t, std::map<uint64_t, double>>::const_iterator cellIdIt =
-             m_pathlossMap.begin();
-         cellIdIt != m_pathlossMap.end();
-         ++cellIdIt)
+    for (auto cellIdIt = m_pathlossMap.begin(); cellIdIt != m_pathlossMap.end(); ++cellIdIt)
     {
-        for (std::map<uint64_t, double>::const_iterator imsiIt = cellIdIt->second.begin();
-             imsiIt != cellIdIt->second.end();
-             ++imsiIt)
+        for (auto imsiIt = cellIdIt->second.begin(); imsiIt != cellIdIt->second.end(); ++imsiIt)
         {
             std::cout << "CellId: " << cellIdIt->first << " IMSI: " << imsiIt->first
                       << " pathloss: " << imsiIt->second << " dB" << std::endl;
@@ -57,12 +52,12 @@
 LteGlobalPathlossDatabase::GetPathloss(uint16_t cellId, uint64_t imsi)
 {
     NS_LOG_FUNCTION(this);
-    std::map<uint16_t, std::map<uint64_t, double>>::iterator cellIt = m_pathlossMap.find(cellId);
+    auto cellIt = m_pathlossMap.find(cellId);
     if (cellIt == m_pathlossMap.end())
     {
         return std::numeric_limits<double>::infinity();
     }
-    std::map<uint64_t, double>::iterator ueIt = cellIt->second.find(imsi);
+    auto ueIt = cellIt->second.find(imsi);
     if (ueIt == cellIt->second.end())
     {
         return std::numeric_limits<double>::infinity();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/helper/lte-helper.cc ns-3.40/src/lte/helper/lte-helper.cc
--- ns-3.39/src/lte/helper/lte-helper.cc	2023-07-05 14:23:47.901427700 -0700
+++ ns-3.40/src/lte/helper/lte-helper.cc	2023-09-27 13:30:37.702839100 -0700
@@ -487,7 +487,7 @@
     NS_LOG_FUNCTION(this);
     Initialize(); // will run DoInitialize () if necessary
     NetDeviceContainer devices;
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         Ptr<Node> node = *i;
         Ptr<NetDevice> device = InstallSingleEnbDevice(node);
@@ -501,7 +501,7 @@
 {
     NS_LOG_FUNCTION(this);
     NetDeviceContainer devices;
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         Ptr<Node> node = *i;
         Ptr<NetDevice> device = InstallSingleUeDevice(node);
@@ -531,8 +531,7 @@
                                     << ")");
     // create component carrier map for this eNb device
     std::map<uint8_t, Ptr<ComponentCarrierBaseStation>> ccMap;
-    for (std::map<uint8_t, ComponentCarrier>::iterator it = m_componentCarrierPhyParams.begin();
-         it != m_componentCarrierPhyParams.end();
+    for (auto it = m_componentCarrierPhyParams.begin(); it != m_componentCarrierPhyParams.end();
          ++it)
     {
         Ptr<ComponentCarrierEnb> cc = CreateObject<ComponentCarrierEnb>();
@@ -752,7 +751,7 @@
     dev->SetAttribute("CellId", UintegerValue(cellId));
     dev->SetAttribute("LteEnbComponentCarrierManager", PointerValue(ccmEnbManager));
     dev->SetCcMap(ccMap);
-    std::map<uint8_t, Ptr<ComponentCarrierBaseStation>>::iterator it = ccMap.begin();
+    auto it = ccMap.begin();
     dev->SetAttribute("LteEnbRrc", PointerValue(rrc));
     dev->SetAttribute("LteHandoverAlgorithm", PointerValue(handoverAlgorithm));
     dev->SetAttribute(
@@ -848,8 +847,7 @@
                                     << ")");
     std::map<uint8_t, Ptr<ComponentCarrierUe>> ueCcMap;
 
-    for (std::map<uint8_t, ComponentCarrier>::iterator it = m_componentCarrierPhyParams.begin();
-         it != m_componentCarrierPhyParams.end();
+    for (auto it = m_componentCarrierPhyParams.begin(); it != m_componentCarrierPhyParams.end();
          ++it)
     {
         Ptr<ComponentCarrierUe> cc = CreateObject<ComponentCarrierUe>();
@@ -867,9 +865,7 @@
     // CC map is not needed anymore
     m_componentCarrierPhyParams.clear();
 
-    for (std::map<uint8_t, Ptr<ComponentCarrierUe>>::iterator it = ueCcMap.begin();
-         it != ueCcMap.end();
-         ++it)
+    for (auto it = ueCcMap.begin(); it != ueCcMap.end(); ++it)
     {
         Ptr<LteSpectrumPhy> dlPhy = CreateObject<LteSpectrumPhy>();
         Ptr<LteSpectrumPhy> ulPhy = CreateObject<LteSpectrumPhy>();
@@ -971,9 +967,7 @@
     nas->SetAsSapProvider(rrc->GetAsSapProvider());
     rrc->SetAsSapUser(nas->GetAsSapUser());
 
-    for (std::map<uint8_t, Ptr<ComponentCarrierUe>>::iterator it = ueCcMap.begin();
-         it != ueCcMap.end();
-         ++it)
+    for (auto it = ueCcMap.begin(); it != ueCcMap.end(); ++it)
     {
         rrc->SetLteUeCmacSapProvider(it->second->GetMac()->GetLteUeCmacSapProvider(), it->first);
         it->second->GetMac()->SetLteUeCmacSapUser(rrc->GetLteUeCmacSapUser(it->first));
@@ -1009,9 +1003,7 @@
     // when the default PDP context is created. This is a simplification.
     dev->SetAddress(Mac64Address::Allocate());
 
-    for (std::map<uint8_t, Ptr<ComponentCarrierUe>>::iterator it = ueCcMap.begin();
-         it != ueCcMap.end();
-         ++it)
+    for (auto it = ueCcMap.begin(); it != ueCcMap.end(); ++it)
     {
         Ptr<LteUePhy> ccPhy = it->second->GetPhy();
         ccPhy->SetDevice(dev);
@@ -1047,7 +1039,7 @@
 LteHelper::Attach(NetDeviceContainer ueDevices)
 {
     NS_LOG_FUNCTION(this);
-    for (NetDeviceContainer::Iterator i = ueDevices.Begin(); i != ueDevices.End(); ++i)
+    for (auto i = ueDevices.Begin(); i != ueDevices.End(); ++i)
     {
         Attach(*i);
     }
@@ -1089,7 +1081,7 @@
 LteHelper::Attach(NetDeviceContainer ueDevices, Ptr<NetDevice> enbDevice)
 {
     NS_LOG_FUNCTION(this);
-    for (NetDeviceContainer::Iterator i = ueDevices.Begin(); i != ueDevices.End(); ++i)
+    for (auto i = ueDevices.Begin(); i != ueDevices.End(); ++i)
     {
         Attach(*i, enbDevice);
     }
@@ -1130,7 +1122,7 @@
 LteHelper::AttachToClosestEnb(NetDeviceContainer ueDevices, NetDeviceContainer enbDevices)
 {
     NS_LOG_FUNCTION(this);
-    for (NetDeviceContainer::Iterator i = ueDevices.Begin(); i != ueDevices.End(); ++i)
+    for (auto i = ueDevices.Begin(); i != ueDevices.End(); ++i)
     {
         AttachToClosestEnb(*i, enbDevices);
     }
@@ -1144,7 +1136,7 @@
     Vector uepos = ueDevice->GetNode()->GetObject<MobilityModel>()->GetPosition();
     double minDistance = std::numeric_limits<double>::infinity();
     Ptr<NetDevice> closestEnbDevice;
-    for (NetDeviceContainer::Iterator i = enbDevices.Begin(); i != enbDevices.End(); ++i)
+    for (auto i = enbDevices.Begin(); i != enbDevices.End(); ++i)
     {
         Vector enbpos = (*i)->GetNode()->GetObject<MobilityModel>()->GetPosition();
         double distance = CalculateDistance(uepos, enbpos);
@@ -1164,7 +1156,7 @@
                                       Ptr<EpcTft> tft)
 {
     NS_LOG_FUNCTION(this);
-    for (NetDeviceContainer::Iterator i = ueDevices.Begin(); i != ueDevices.End(); ++i)
+    for (auto i = ueDevices.Begin(); i != ueDevices.End(); ++i)
     {
         uint8_t bearerId = ActivateDedicatedEpsBearer(*i, bearer, tft);
         return bearerId;
@@ -1324,9 +1316,9 @@
 
     NS_ASSERT_MSG(m_epcHelper, "X2 interfaces cannot be set up when the EPC is not used");
 
-    for (NodeContainer::Iterator i = enbNodes.Begin(); i != enbNodes.End(); ++i)
+    for (auto i = enbNodes.Begin(); i != enbNodes.End(); ++i)
     {
-        for (NodeContainer::Iterator j = i + 1; j != enbNodes.End(); ++j)
+        for (auto j = i + 1; j != enbNodes.End(); ++j)
         {
             AddX2Interface(*i, *j);
         }
@@ -1444,7 +1436,7 @@
 LteHelper::ActivateDataRadioBearer(NetDeviceContainer ueDevices, EpsBearer bearer)
 {
     NS_LOG_FUNCTION(this);
-    for (NetDeviceContainer::Iterator i = ueDevices.Begin(); i != ueDevices.End(); ++i)
+    for (auto i = ueDevices.Begin(); i != ueDevices.End(); ++i)
     {
         ActivateDataRadioBearer(*i, bearer);
     }
@@ -1585,15 +1577,14 @@
         }
     }
     Ptr<NetDevice> netDevice;
-    for (NetDeviceContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         netDevice = (*i);
         Ptr<LteEnbNetDevice> lteEnb = DynamicCast<LteEnbNetDevice>(netDevice);
         if (lteEnb)
         {
             std::map<uint8_t, Ptr<ComponentCarrierBaseStation>> tmpMap = lteEnb->GetCcMap();
-            std::map<uint8_t, Ptr<ComponentCarrierBaseStation>>::iterator it;
-            it = tmpMap.begin();
+            auto it = tmpMap.begin();
             Ptr<LteSpectrumPhy> dlPhy =
                 DynamicCast<ComponentCarrierEnb>(it->second)->GetPhy()->GetDownlinkSpectrumPhy();
             Ptr<LteSpectrumPhy> ulPhy =
@@ -1605,8 +1596,7 @@
         if (lteUe)
         {
             std::map<uint8_t, Ptr<ComponentCarrierUe>> tmpMap = lteUe->GetCcMap();
-            std::map<uint8_t, Ptr<ComponentCarrierUe>>::iterator it;
-            it = tmpMap.begin();
+            auto it = tmpMap.begin();
             Ptr<LteSpectrumPhy> dlPhy = it->second->GetPhy()->GetDownlinkSpectrumPhy();
             Ptr<LteSpectrumPhy> ulPhy = it->second->GetPhy()->GetUplinkSpectrumPhy();
             Ptr<LteUeMac> ueMac = lteUe->GetMac();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/helper/no-backhaul-epc-helper.cc ns-3.40/src/lte/helper/no-backhaul-epc-helper.cc
--- ns-3.39/src/lte/helper/no-backhaul-epc-helper.cc	2023-07-05 14:23:47.901427700 -0700
+++ ns-3.40/src/lte/helper/no-backhaul-epc-helper.cc	2023-09-27 13:30:37.702839100 -0700
@@ -540,7 +540,7 @@
 Ipv6InterfaceContainer
 NoBackhaulEpcHelper::AssignUeIpv6Address(NetDeviceContainer ueDevices)
 {
-    for (NetDeviceContainer::Iterator iter = ueDevices.Begin(); iter != ueDevices.End(); iter++)
+    for (auto iter = ueDevices.Begin(); iter != ueDevices.End(); iter++)
     {
         Ptr<Icmpv6L4Protocol> icmpv6 = (*iter)->GetNode()->GetObject<Icmpv6L4Protocol>();
         icmpv6->SetAttribute("DAD", BooleanValue(false));
